



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Hibernate核心组件详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Hibernate核心组件详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 01:05:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Hibernate是对象/关系映射(ORM，Object/Relational Mapping)的解决方案，就是将Java对象与对象关系映射到关系型数据库中的表格与表格之间的关系。它是Java应用与关系数据库之间的桥梁，负责Java对象和关系数据之间的映射。Hibernate内部封装了通过JDBC访问数据库的操作，向上层应用提供了面向对象的数据库访问API。</p>
<p><strong>Hibernate的体系结构</strong></p>
<p>Hibernate通过配置文件( hibernate.cfg.xml )和映射文件( *.hbm.xml )把Java对象或持久化对象( Persistent Object，PO )映射到数据库的表格，然后通过操作PO，对数据表中的数据进行增、删、改、查等操作。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/990022/201607/990022-20160720135845185-88974567.png" /></p>
<p><strong>Hibernate的核心组件</strong></p>
<p>　　1、Hibernate配置文件(hibernate.cfg.xml)：</p>
<p>　　主要用来配置数据库连接参数，如数据库驱动程序、URL、用户名、密码等。hibernate.cfg.xml还在其&lt;mapping&gt;子元素中定义用到的xxx.hbm.xml映射文件列表</p>
<p>　　2、映射文件(xxx.hbm.xml)：</p>
<p>　　用来把PO与数据库中的数据表、PO之间的关系与数据库之间的关系、以及PO的属性与表字段一一映射起来，是Hibernate的核心文件</p>
<p>　　每个PO类对应一个映射文件，和该PO类在同一个目录下</p>
<p>　　</p>
<p>　　3、Configuration类：</p>
<p>　　用来读取Hibernate配置文件，并生成SessionFactory对象。</p>
<p>　　负责管理Hibernate配置信息。执行Configuration conf=new Configuration().configure()语句时，Hibernate自动在CLASSPATH中搜寻Hibernate配置文件；在Java Web应用中，则在WEB-INF/classes目录下搜寻配置文件。还可以指定配置文件的位置，如：</p>
<div>
<pre class="prettyprint linenums">File file=new File("C:\\Users\\Administrator\\Desktop\\dfd\\Hibernate_Proj\\src\\hibernate.cfg.xml");<br />
Configuration cfg=new Configuration().configure(file);</pre>
</div>
<p>　　4、SessionFactory接口：</p>
<p>　　产生Session实例的工厂，负责Session实例的创建，可通过Configuration创建SessionFactory</p>
<div>
<pre class="prettyprint linenums">Configuration cfg=new Configuration().configure();<br />
SessionFactory sf=cfg.buildSessionFactory();</pre>
</div>
<p>　　SessionFactory线程安全，可以被多线程调用以取得Session</p>
<p>　　5、Session接口：</p>
<p>　　用来操作持久化对象PO。有get()、load()、save()、update()、delete()等方法用来对PO进行加载、保存、更新及删除等操作，是Hibernate的核心接口</p>
<p>　　是应用程序与数据库之间的一个会话，是Hibernate运作中心，相当于JDBC中的Connection。通过SessionFactory创建</p>
<p>　　6、Query接口：</p>
<p>　　Query负责执行各种数据库查询。它可以使用HQL语言对PO进行查询操作。Query对象可以使用Session的createQuery()方法生成</p>
<p>　　(1)setXxx ( )：用于设置HQL中问号或变量的值</p>
<p>　　(2)list&nbsp;( )：返回查询结果，并把查询结果转换成List对象</p>
<p>　　(3)excuteUpdate ( )：执行批量更新或批量删除语句</p>
<p>　　7、Transaction接口：</p>
<p>　　用来管理Hibernate事务，主要方法有commit()和rollback()，可从Session的beginTransaction()方法生成</p>
<p>　　8、持久化对象(PO):</p>
<p>　　一个持久化类就是普通的JavaBean，但是它与Session关联起来后，就具有了持久化的能力。每一个数据表对应一个持久化对象(PO)，PO可以看成是与数据库表相映射的Java对象，PO类中不应该包含任何对数据的操作，唯一特殊的是他们与Session相关联。</p>
<p>　　</p>
<p>　　PO对象在Hibernate中存在三种状态：</p>
<p>　　(1)临时状态(transient)：</p>
<p>　　由new命令开辟内存空间刚生成的Java对象就处于临时态。临时对象在内存中是孤立存在的，不和数据库的数据有任何关联关系。在Hibernate中，可通过Session的save()或saveOrUpdate()方法将临时对象与数据库相关联，并将数据插入到数据库中，此时转变成持久化对象。</p>
<p>　　(2)持久状态(persistent)：</p>
<p>　　处于持久态的对象也称为PO，处于该状态的对象在数据库中具有对应的记录，并拥有一个持久化标识。如果使用Hibernate的delete()方法，对应的持久对象就变成临时对象，因数据库中的对应数据已被删除，该对象不再与数据库的记录关联。</p>
<p>　　当一个Session执行close()或clear()之后，持久对象变成脱管对象。</p>
<p>　　持久对象的特点：和Session实例关联、在数据库中有与之关联的记录。</p>
<p>　　(3)脱管状态(detached)：</p>
<p>　　当与某持久对象关联的Session被关闭后，该持久对象转变为脱管对象。当脱管对象被重新关联到Session上时，将再次转变成持久对象。</p>
<p>　　脱管对象拥有数据库的标识值，可通过update()、saveOrUpdate()等方法，转变成持久对象</p>
<p><strong>save()、update()、saveOrUpdate()的区别：</strong></p>
<p>save()：的作用是保存一个新的临时对象到数据库，变成持久对象；</p>
<p>update()：可以把一个脱管状态的对象（一定要和一个记录对应）更新到数据库，变成持久对象</p>
<p>saveOrUpdate()：合并了save()和update()，因为有时候不知道一个对象是临时对象还是脱管对象，saveOrUpdate()首先判断该对象是临时还是脱管对象，再调用合适的方法。</p>
<p>　</p>
<p><strong>Hibernate的运行过程</strong></p>
<p><strong>　　</strong>(1)&nbsp;应用程序调用Configuration类，该类读取Hibernate配置文件级映射文件中的信息，并生成一个SessionFactory</p>
<p>　　(2) 从SessionFactory对象生成一个Session对象，并用Session对象生成Transaction对象</p>
<p>　　(3) 通过Session对象的get()、load()、save()、update()、delete()、saveOrUpdate()等方法对PO进行加载、保存、更新、删除等操作；通过Session对象生成一个Query对象，进行查询操作</p>
<p>　　(4) 如无异常，Transaction对象将提交这些操作结果到数据库中</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/990022/201607/990022-20160720140433513-1860062632.png" /></p>
<p>参考书籍：Java Web技术整合应用与项目实战（张志峰等编著）</p>
<p>参考：<a href="http://www.cnblogs.com/cqq626/p/4330105.html" rel="external nofollow noreferrer">Java Web编程的主要组件技术&mdash;&mdash;Hibernate核心组件</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ok0vx9.html">5805 NanoApe Loves Sequence（想法题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvnddo9.html">git log 格式化输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnpvw38.html">Windows 8&period;1 去掉库的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/49523nv9.html">用UltraISO制作支持windows 7的U盘启动盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dw238.html">堆排序 Heap Sort</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmy6j49.html">excel中VBA对多个文件的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojkk5pq.html">JQuery AJAX Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvl6eq.html">谈谈如何从Apache官网扒文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z6rd19.html">【原创】Windows平台下Git的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk0y7v8.html">Cmake用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1gp59.html">Winform外包团队 项目案例展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv0pnk8.html">iptables命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyygmj2q.html">UnicodeMath编码教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjkw6j9.html">Android仿淘宝继续上拉进入商品详情页的效果，使用双Fragment动画切换；</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlwe48.html">spring boot编译项目打jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r050z8.html">C&num;中Graphics的画图代码【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pxown8.html">python中 除了if else def class 有作用域 其余没有作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2orvv8.html">【第二十八章】 springboot &plus; zipkin（brave定制-AsyncHttpClient）</a>
		</li>
						<li><a href="https://www.batexi.com/a/953zmw68.html">CSS 相对&sol;绝对&lpar;relative&sol;absolute&rpar;定位系列（四）&mdash;&mdash;张鑫旭</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj1e47q.html">python AES 加密</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/902jlg3q.html">c&plus;&plus;类定义代码的分离</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl5edy9.html">js 注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjd3x7q.html">Spring Cloud微服务体系搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1nd109.html">BZOJ2563&colon; 阿狸和桃子的游戏 贪心</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pdrkn8.html">&lbrack;SpringMVC&rsqb; - 简单说明什么是SpringMVC</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em5kzk9.html">UVa 10570 外星人聚会</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjdvm0q.html">UVa 1331 最大面积最小的三角剖分</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl52yk9.html">vs2010&lowbar;相关目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8konxyjq.html">Codeforces D - The Child and Zoo</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv4m3dq.html">C&num; DataTable按指定列排序</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
